
lorom

; ------------------------------------- Defines -------------------------------------

; Letters.
!A = $C0 : !B = $C1
!C = $C2 : !D = $C3
!E = $C4 : !F = $C5
!G = $C6 : !H = $C7
!I = $C8 : !J = $C9
!K = $CA : !L = $CB
!M = $CC : !N = $CD
!O = $CE : !P = $CF
!Q = $D0 : !R = $D1
!S = $D2 : !T = $D3
!U = $D4 : !V = $D5
!W = $D6 : !X = $D7
!Y = $D8 : !Z = $D9

; Numbers.
!n1 = $00 : !n2 = $01
!n3 = $02 : !n4 = $03
!n5 = $04 : !n6 = $05
!n7 = $06 : !n8 = $07
!n9 = $08 : !n0 = $09

; Punctuation.
!period = $DA : !comma = $DB
!quotestart = $DC : !quoteend = $DC
!question = $DE : !exclamation = $DF
!dash = $BE : !percent = $0A : !_ = $0F

; Colors.
!red = $28 : !yellow = $3C
!green = $38 : !blue = $2C

; Message Boxes.
!Big = #$825A : !Small = #$8289
!EmptySmall = #$8436 : !EmptyBig = #$877A


; ---------------------------------- BANK $82 -----------------------------------------

org $82A136
	dw $FB0C 	; Rewrite LDA.
org $82A152
	dw $FB0C 	; Rewrite LDA.
org $82A16E
	dw $C06A	; Rewrite LDA.
org $82A181
	dw $FB00	; Rewrite LDA.
org $82A196
	dw $FB18	; Rewrite LDX.
org $82A1A1
	dw $FB00	; Rewrite LDA.
org $82ABC6
	dw $FB00	; Rewrite BIT.
org $82ABCD
	dw $000C 	; Rewrite CPX.
org $82B04F
	dw $0501 	; Rewrite CMP.
org $82B175
	dw $000A	; Rewrite LDX.
org $82B462
	dw $FB00 	; Rewrite BIT.
org $82B469
	dw $000C	; Rewrite CPX.
org $82B495
	dw $FB00 	; Rewrite BIT.
org $82C02C
	dw $FB0C	; \ 
	dw $C06A	; / Rewrite Pointers to start of RAM offsets for specific tilemaps.
org $82C036
	dw $FB00	; Rewrite Pointers to bit checklists.
org $82C046
	dw $FB18	; Rewrite Indirect pointer to tilemaps for enabled items.
org $82C06A
	dw $3BC8	; Rewrite RAM offset for a specific tilemap.
org $82C18E
	dw $FB00	; \ 
	dw $C19A	; / Pointers to animation loops?
org $82C19A
	db $30,$00,$7C	; Animation Loop data?

org $82FB00
	dw $2000,$1000,$0002,$0001,$0004,$0008	; Beam bit checklist, $2000 is Long Beam.
	dw $3A88,$3AC8							; RAM offsets for specific tilemaps [$82FB0C).
	db $1B,$00,$54,$00,$1B,$00,$5C,$00		; ($82FB10).
	dw $FB24,$BF32,$BF3C,$BF46,$BF50,$BF5A	; Tilemap pointers for enabled items ($82FB18).
	dw $0AFF,$0AA4,$0AA5,$0AA6,$0AD4		; Tilemap for enabled long beam ($82FB24).

org $82FB2E
	LDA #$0004 : TRB $09A6 : JSR $90AC8D : RTL


;------------------------------------ BANK $84 ----------------------------------------

; There are three types of items in Super Metroid: 
;	The regular type, used by morph ball.
;	Inside a chozo ball, used by major item upgrades.
;	Hidden inside a shot block.
; To make it easy to select which type, just uncomment below the one you want.
; You can only choose one type, as there is no reason to use all types in the game.

;incsrc LongBeamHidden.asm
;incsrc LongBeamBall.asm
incsrc LongBeamItem.asm

;------------------------------------ BANK $85 ----------------------------------------

org $858243
	JSR $8749

org $8582E5
	JSR $8749

org $858413
	dw ButtonArray

org $858749
	LDA $1C1F : CMP #$001D : BPL + : RTS
+	ADC #$0297 : RTS

	REP #30 : LDA $09B4 : BRA $1A 	;Jump
	REP #30 : LDA $09B8 : BRA $13 	;ItemCancel
	REP #30 : LDA $09BA : BRA $0C 	;ItemSelect
	REP #30 : LDA $09BC : BRA $05 	;AimDown
	REP #30 : LDA $09BE : JMP $83D1 ;AimUp
	REP #30 : JMP $8409				;EmptyBig

org $8596D3
	dw !EmptySmall, !Small, LongBeam
	dw !EmptySmall, !Small, ButtonArray

LongBeam:
	dw $000E, $000E, $000E, $000E, $000E, $000E
	db !_, !red
	db !_, !red
	db !_, !red
	db !_, !red
	db !_, !red
	db !L, !red
	db !O, !red
	db !N, !red
	db !G, !red
	db !_, !red
	db !B, !red
	db !E, !red
	db !A, !red
	db !M, !red
	db !_, !red
	db !_, !red
	db !_, !red
	db !_, !red
	db !_, !red
	dw $000E, $000E, $000E, $000E, $000E, $000E, $000E

ButtonArray:
	dw $0000, $012A, $012A, $012C, $012C, $012C, $0000, $0000
	dw $0000, $0000, $0000, $0000, $0120, $0000, $0000, $0000
	dw $0000, $0000, $012A, $0000, $0000, $0000, $0000, $0000
	dw $0000, $0000, $0000, $0000, $0000


;------------------------------------ BANK $89 ----------------------------------------

org $899700 ; Graphics for the Long Beam Item.
;	incbin LongBeamGraphics.bin		; Use this instead if you want your own item graphic.
	db $05,$06,$12,$19,$55,$63,$AC,$CA,$5A,$96,$7A,$A6,$B6,$0E,$F6,$0E
	db $07,$00,$1F,$04,$7F,$08,$FE,$10,$FE,$20,$FE,$00,$FE,$40,$FE,$00
	db $22,$3E,$5D,$73,$1E,$51,$1E,$51,$3E,$51,$5D,$7F,$22,$3E,$00,$00
	db $00,$00,$10,$10,$30,$30,$30,$30,$10,$10,$1C,$1C,$00,$00,$00,$00
	db $69,$9E,$2B,$DC,$94,$CF,$5B,$47,$26,$3F,$7A,$5F,$4B,$5B,$0A,$2E
	db $FF,$00,$FF,$00,$FF,$20,$7F,$20,$3F,$00,$7F,$00,$7F,$24,$2E,$00
	db $9B,$07,$BD,$7E,$CF,$FD,$7E,$F6,$DF,$DB,$FF,$72,$56,$8F,$FE,$FA
	db $FF,$60,$FF,$00,$FF,$00,$FE,$00,$FF,$20,$FF,$00,$FF,$20,$FE,$00
	db $02,$04,$09,$10,$22,$41,$42,$88,$84,$12,$84,$22,$08,$06,$08,$06
	db $07,$00,$1F,$04,$7F,$08,$FE,$10,$FE,$20,$FE,$00,$FE,$40,$FE,$00
	db $1C,$22,$3E,$51,$5F,$10,$5F,$10,$7F,$10,$3E,$5D,$1C,$22,$00,$00
	db $00,$00,$10,$10,$30,$30,$30,$30,$10,$10,$1C,$1C,$00,$00,$00,$00
	db $96,$08,$D4,$08,$4B,$84,$04,$43,$19,$26,$05,$5A,$10,$4B,$24,$0A
	db $FF,$00,$FF,$00,$FF,$20,$7F,$20,$3F,$00,$7F,$00,$7F,$24,$2E,$00
	db $00,$07,$42,$3C,$30,$CD,$88,$76,$00,$DB,$00,$72,$89,$06,$00,$FA
	db $FF,$60,$FF,$00,$FF,$00,$FE,$00,$FF,$20,$FF,$00,$FF,$20,$FE,$00


;------------------------------------ BANK $8B ----------------------------------------

org $8BE65C
	db $1E	; Rewrite LDX.
org $8BE673
	db $31	; Rewrite BIT,x.
org $8BE721
	dw $0010,$0020,$0040,$0080,$0002,$0008,$0004,$0001	; $09A4 test bits.


;-------------------------------  BANK $90 + $91 --------------------------------------

org $90AF33
	dw $FA00 ; Hijack to Long Beam code.
org $90B124
	dw $FA00 ; Hijack to Long Beam code.

org $90FA00
	LDA $09A6 : AND #$2000 : BNE + ; Bit check if Long Beam is equipped.
	LDX $0DDE : LDA $0C18,x : AND #$0010 : BEQ ++

	LDA $0B64,x : SEC : SBC $0AF6 : CMP #$FFA0 : BMI +++ ; How far a Charge shot pointing left can go.
	CMP #$0060 : BPL +++ ; How far a Charge shot pointing right can go.
	LDA $0B78,x : SEC : SBC $0AFA : CMP #$FF88 : BMI +++ ; How far a Charge shot pointing up can go.
	CMP #$0068 : BPL +++ ; How far a Charge shot pointing down can go.
	BRA +

++	LDA $0B64,x : SEC : SBC $0AF6 : CMP #$FFC0 : BMI +++ ; How far a normal shot pointing left can go.
	CMP #$0040 : BPL +++ ; How far a normal shot pointing right can go.
	LDA $0B78,x : SEC : SBC $0AFA : CMP #$FFA8 : BMI +++ ; How far a normal shot pointing up can go.
	CMP #$0048 : BMI + ; How far a normal shot pointing down can go.

+++	JMP $B17E
+	JMP $B16A
	
org $91E5F3
	TSB $09A6 : JSL $82FB2E


;------------------------------------ BANK $B6 ----------------------------------------

; The "Long" graphics for the Equipment Subscreen. Only needed for DC's Map patch.
org $B6D480
	db $FF,$FF,$FF,$FF,$BC,$FF,$BB,$FF,$BB,$FF,$BB,$FF,$8C,$FF,$FF,$FF
	db $00,$FF,$00,$FF,$00,$FF,$00,$FF,$00,$FF,$00,$FF,$00,$FF,$00,$FF
	db $FF,$FF,$FF,$FF,$DB,$FF,$4A,$FF,$42,$FF,$52,$FF,$DB,$FF,$FF,$FF
	db $00,$FF,$00,$FF,$00,$FF,$00,$FF,$00,$FF,$00,$FF,$00,$FF,$00,$FF
	db $FF,$FF,$FF,$FF,$1F,$FF,$FF,$FF,$9F,$FF,$DF,$FF,$1F,$FF,$FF,$FF
	db $00,$FF,$00,$FF,$00,$FF,$00,$FF,$00,$FF,$00,$FF,$00,$FF,$00,$FF

; Adds Long Beam to the Equipment Subscreen tilemap.
org $B6EB86
	dw $3941,$3943,$3AF9,$3AFA,$3AFB,$7943,$7941
org $B6EBC6
	dw $3940,$0AFF,$0AA4,$0AA5,$0AA6,$0AD4,$7940





